
/**
 * Intermediate representation of a UxOut for sorting and spend choosing.
 */
typedef struct {
  cipher__SHA256   Hash;     ///< Hash of underlying UxOut.
  GoInt64_ BkSeq;           ///< Block height corresponding to the
                            ///< moment balance calculation is performed at.
  cipher__Address  Address;  ///< Account holder address.
  GoInt64_ Coins;           ///< Coins amount (e.g. in SKY).
  GoInt64_ Hours;           ///< Balance of Coin Hours generated by underlying UxOut, depending on UxOut's head time.
} wallet__UxBalance;
